package Entity 
{
	import flash.accessibility.ISearchableText;
	import flash.display.BitmapData;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	/**
	 * ...
	 * @author lightsoda
	 */
	public class BaseEntity extends Entity
	{
		protected var oldx:Number;
		protected var oldy:Number;
		protected var newx:Number;
		protected var newy:Number;

		protected var m_map:Entity;
		protected var m_player:Entity;
		protected var m_knife:Entity;
		protected var m_npc:Array;
		
		protected var m_moveSpeed:Number;
		
		protected var m_collidingWithNpc:Boolean;
		
		protected var m_interactTarget:ENpc;
		
		public var m_hasKnife:Boolean = false;
		
		public function BaseEntity(x:Number, y:Number) 
		{
			super(x, y);
			m_moveSpeed = C.MOVE_SPEED;
			layer = 10;
		}
	
		public function CreatePlaceholderImage(w:Number, h:Number, color:uint = 0x000000, center:Boolean = false):Image
		{
			var placeholderImage:Image;
			placeholderImage = new Image(new BitmapData(w, h));
			placeholderImage.color = color;
			if (center)
			{
				placeholderImage.originX = placeholderImage.width / 2;
				placeholderImage.originY = placeholderImage.height / 2;
			}
			//setHitbox(w, h, placeholderImage.originX, placeholderImage.originY);
			return placeholderImage;
		}
		

		override public function update():void 
		{
			oldx = x;
			oldy = y;
			
			super.update();
		}
		
		private function GetCollidables(x:Number, y:Number):Boolean
		{
			m_map = world.typeFirst(C.TYPE_MAP);
			m_player = world.typeFirst(C.TYPE_PLAYER);
			m_knife = world.typeFirst(C.TYPE_KNIFE);
			
			m_npc = new Array();
			world.getType(C.TYPE_NPC, m_npc);
			
			if (type == C.TYPE_PLAYER)
			{
				var npc:ENpc;
				for each(npc in m_npc)
				{
					if (collideWith(npc, x, y)) {
						if (npc.m_conversationState != C.STATE_DONE)
						{
							m_collidingWithNpc = true;
							m_interactTarget = npc;
							//return true;
						}
					}
				}

				if (collideWith(m_knife, x, y) && !m_hasKnife)
				{
					m_hasKnife = true;
					world.add(new ETempDialog(0, 0, "You found a knife"));
				}
			}

			if (m_map != null)
			{
				if (collideWith(m_map, x, y))
				{
					return true;
				}
			}
			
			if (m_player != null && type != C.TYPE_PLAYER)
			{
				if (collideWith(m_player, x, y))
				return true;
			}
			
			return false;
		}
		
		protected function MoveLeft():void
		{
			oldx = newx = x;
			
			newx -= m_moveSpeed * FP.elapsed;

			if (GetCollidables(newx, oldy))
			{
				x = oldx;
			}
			else x = newx;
		}
		
		protected function MoveRight():void
		{
			oldx = newx = x;
		
			newx += m_moveSpeed * FP.elapsed;
			
			if (GetCollidables(newx, oldy))
			{
				x = oldx;
			}
			else x = newx;
		}
		
		protected function MoveUp():void
		{
			oldy = newy = y;
			
			newy -= m_moveSpeed * FP.elapsed;
			
			if (GetCollidables(oldx, newy))
			{
				y = oldy;
			}
			else y = newy;
		}
			
		protected function MoveDown():void
		{
			oldy = newy = y;
			
			newy += m_moveSpeed * FP.elapsed;
			
			if (GetCollidables(oldx, newy))
			{
				y = oldy;
			}
			else y = newy;
		}
			
		protected function Shoot():void
		{
			//world.add(new Bullet(x, y));
		}
		
	}

}