package Entity 
{
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author lightsoda
	 */
	public class EButton extends BaseEntity
	{
		private var placeholderImage:Image;
		private var callback:Function;
		private var text:String;
		
		public function EButton(x:Number, y:Number, text:String, callback:Function) 
		{
			super(x, y);
			
			this.callback = callback;
			this.text = text;
			
			placeholderImage = CreatePlaceholderImage(140, 40, 0xff0000, true);
			setHitboxTo(placeholderImage);
			
			var t:Text = new Text(text, 0, 0);
			t.originX = t.width / 2;
			t.originY = t.height / 2;
			
			graphic = new Graphiclist(placeholderImage, t);
		}

		override public function update():void 
		{
			if (collidePoint(x, y, world.mouseX, world.mouseY))
			{
				placeholderImage.scale += (1.2 - placeholderImage.scale) / 2;
				if (Input.mouseReleased && callback != null)
				{
					callback();
				}
			}
			else
			{
				placeholderImage.scale += (1 - placeholderImage.scale) / 2;
			}
			
			super.update();
		}
		
		override public function render():void 
		{
			super.render();
		}
		
	}

}