package Worlds 
{
	import Entity.EKnife;
	import Entity.EPlayer;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.graphics.Tilemap;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.utils.Draw;
	/**
	 * ...
	 * @author lightsoda
	 */
	public class GameWorld extends BaseWorld
	{
		public var m_deathTimer:Number;
		private var m_deathTimerCooldown:Number;
		
		private var m_deathText:Text;
		private var m_deathTextEntity:Entity;
		
		private var m_player:EPlayer;
		
		public var m_persistent:P;
		
		public function GameWorld(p:P) 
		{
			m_deathText = new Text("");
			m_deathText.color = 0xFF0000;
			m_deathTimer = 10;
			m_deathTimerCooldown = 2;
			
			m_paused = false;
			
			m_persistent = p;
			m_persistent.PlayMusic("main");
			
			FP.screen.color = C.COLOR_BACKGROUND_INGAME;
		}

		override public function begin():void 
		{
			m_deathTextEntity = new Entity();
			m_deathTextEntity.graphic = m_deathText;
			
			CreateLevel();
			
			m_player = new EPlayer(m_mapXML.entities.playerstart.@x, m_mapXML.entities.playerstart.@y);
			add(m_player);
			
			add(new EKnife(m_mapXML.entities.knife.@x, m_mapXML.entities.knife.@y));
			
			add(m_deathTextEntity);
			
			super.begin();
		}
		
		override public function update():void 
		{
			if (!m_paused)
			{
				if (m_deathTimerCooldown <= 0)
				{
					if (m_deathTimer > 0)
					{
						m_deathTimer -= 1 * FP.elapsed;
					}
					
					if (m_deathTimer <= 0)
					{
						FP.world = new WDeath(m_persistent);
					}
				}
				else m_deathTimerCooldown -= 1 * FP.elapsed;
			}
			
			m_deathText.text = "Time to death: " + int(m_deathTimer);
			m_deathText.x = camera.x;
			m_deathText.y = camera.y;
			
			SetCameraTo(m_player);
			
			super.update();
		}
		
		override public function render():void 
		{
			super.render();
		}
		
	}

}