package Worlds 
{
	import Entity.EButton;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	/**
	 * ...
	 * @author lightsoda
	 */
	public class WIntro extends BaseWorld
	{
		private var introText:String = "You have 10 seconds to live\nHow will you spend your last moments?\n\nEnter: Interact\nArrow keys: Walk/Select";
		
		private var m_persistent:P;
		
		public function WIntro(p:P)
		{
			m_persistent = p;
			m_persistent.PlayMusic("intro");
		}

		override public function begin():void 
		{
			add(new EButton(C.GAME_WIDTH / 2, C.GAME_HEIGHT / 2, "Start", function():void { FP.world = new GameWorld(m_persistent) }));
			
			var t:Text = new Text(introText, 30, 40)
			t.color = 0x000000;
			t.align = "center";
			t.x = C.SCREEN_CENTER_X - t.width / 2;
			
			var e:Entity = new Entity(0, 0);
			e.graphic = new Graphiclist(t);
			add(e);
			
			super.begin();
		}
		
		override public function update():void 
		{
			if (Input.pressed(Key.ENTER))
			{
				FP.world = new GameWorld(m_persistent);
			}
			
			super.update();
		}
		
	}

}